<?

/*
 * Warning ** Warning ** Warning ** Warning ** Warning ** Warning *
 *                                                                *
 * -> this webinterface is ment to be a sample implementation  <- *
 *                                                                *
 * Warning ** Warning ** Warning ** Warning ** Warning ** Warning *
 *
 *
 * Copyright (C) 2006 Tino Reichardt
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License Version 2, as
 * published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

/**
 * Webinterface for squidwall
 *
 * ctime: 2005-06-29
 * mtime: 2006-05-21
 *
 * Beschreibung:
 * 1. Authentifizierung
 * 2. Funktionen definieren
 * 3. Datenbanken prfen und einlesen
 */

if (!isset($no_headers)) {
   header("Expires: Mon, 1 Jan 1999 00:00:00 GMT");
   header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
   header("Cache-Control: no-store, no-cache, must-revalidate");
   header("Cache-Control: post-check=0, pre-check=0", false);
   header("Cache-Control: private" );
   header("Pragma: no-cache");
}

if (get_magic_quotes_gpc()) {
   function stripslashes_deep($value) {
       $value = is_array($value) ?
                   array_map('stripslashes_deep', $value) :
                   stripslashes($value);

       return $value;
   }

   $_POST    = array_map('stripslashes_deep', $_POST);
   $_GET     = array_map('stripslashes_deep', $_GET);
   $_COOKIE  = array_map('stripslashes_deep', $_COOKIE);
   $_REQUEST = array_map('stripslashes_deep', $_REQUEST);
}

/* our webinterface version */
$P_VER = "squidwall 0.5 / 2006-08-06";

include("$P_INT/lang.php");      /* Sprachen */
include("$P_INT/functions.php"); /* Funktionen */
include("$P_INT/auth.php");      /* Benutzerprfung */

/* diverse Verzeichnisse prfen */
if (!is_dir($P_USERS)) { fatal_error("Can't read user definitions !"); }
if (!is_dir($P_HOSTS)) { fatal_error("Can't read host definitions !"); }

$r=180; $g=180; $b=240; $step=5; $count=30;
for ($i=0; $i<$count; $i+=1) {
  $xr = $r+$i*$step; if ($xr > 255) $xr=255;
  $xg = $g+$i*$step; if ($xg > 255) $xg=255;
  $xb = $b+$i*$step; if ($xb > 255) $xb=255;
  if ($xr == 255 && $xg == 255 && $xb == 255) break;
  $C[]="#" . sprintf("%02x", $xr) . sprintf("%02x", $xg) . sprintf("%02x", $xb);
}

$C_ADMIN=$C[$c=0]; $c++;

/* datenbanken raussuchen */
$r=init_defs("$P_INT/hosts", $H);
if ($r) { $C_HOSTS=$C[$c]; $c++; }

$r=init_defs("$P_INT/users", $U);
if ($r) { $C_USERS=$C[$c]; $c++; }

/* banner */
$r=init_filterdir("bfilter",  $BF);
if ($r) { $C_BFILTER=$C[$c]; $c++; }

$r=init_filterdir("bcfilter", $BCF);
if ($r) { $C_BCFILTER=$C[$c]; $c++; }

$r=init_filterdir("brfilter", $BRF);
if ($r) { $C_BRFILTER=$C[$c]; $c++; }

/* content */
$r=init_filterdir("pfilter",  $PF);
if ($r) { $C_PFILTER=$C[$c]; $c++; }

$r=init_filterdir("cfilter",  $CF);
if ($r) { $C_CFILTER=$C[$c]; $c++; }

$r=init_filterdir("crfilter", $CRF);
if ($r) { $C_CRFILTER=$C[$c]; $c++; }

/* url blacklisting */
$r=init_filterdir("ufilter",  $UF);
if ($r) { $C_UFILTER=$C[$c]; $c++; }

$r=init_filterdir("urfilter", $URF);
if ($r) { $C_URFILTER=$C[$c]; $c++; }

$r=init_filterdir("ufilter_md5", $MF);
if ($r) { $C_MFILTER=$C[$c]; $c++; }

$r=init_filterdir("ufilter_sha1", $SF);
if ($r) { $C_SFILTER=$C[$c]; $c++; }

/* url whitelisting */
$r=init_filterdir("wfilter",  $WF);
if ($r) { $C_WFILTER=$C[$c]; $c++; }

$r=init_filterdir("wrfilter", $WRF);
if ($r) { $C_WRFILTER=$C[$c]; $c++; }

/* misc other colors */
$C_REDIR= $C[$c]; $c++;
$C_PPPD=  $C[$c]; $c++;
$C_HELP=  $C[$c]; $c++;
$C_LOGOUT=$C[$c]; $c++;

?>
